/*
bhnumpad.cpp 
Copyright (C) 2004  Al Kingsley

   GPL version 2 or later.

	Part of:
	BhPos, Copyright (C) 2001-2004   Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/
#include "config.h"
#include "bhnumpad.h"

namespace bhpos{

namespace widget{

BhNumPad::BhNumPad(Glib::ustring basedir, NPCALLBACK cb)
{
   kf_callback=cb;
   bCallback=true;
   Glib::ustring ifile;
   
   set_border_width(0);
   set_row_spacings(0);
   set_col_spacings(0);
   this->set_size_request(160, 205);
   
   ifile=basedir + "/keypad_0.png";
   b0=manage(new Gtk::Image(ifile));
   b_0 = manage(new Gtk::Button()); 
   b_0->add(*b0);
   b_0->set_border_width(0);
   b_0->set_relief(Gtk::RELIEF_NONE);
   b_0->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_1.png";
   b1=manage(new Gtk::Image(ifile));
   b_1 = manage(new class Gtk::Button()); 
   b_1->add(*b1);
   b_1->set_border_width(0);
   b_1->set_relief(Gtk::RELIEF_NONE);
   b_1->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_2.png";
   b2=manage(new Gtk::Image(ifile));
   b_2 = manage(new Gtk::Button()); 
   b_2->add(*b2);
   b_2->set_border_width(0);
   b_2->set_relief(Gtk::RELIEF_NONE);
   b_2->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_3.png";
   b3=manage(new Gtk::Image(ifile));
   b_3 = manage(new Gtk::Button()); 
   b_3->add(*b3);
   b_3->set_border_width(0);
   b_3->set_relief(Gtk::RELIEF_NONE);
   b_3->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_4.png";
   b4=manage(new Gtk::Image(ifile));
   b_4 = manage(new Gtk::Button()); 
   b_4->add(*b4);
   b_4->set_border_width(0);
   b_4->set_relief(Gtk::RELIEF_NONE);
   b_4->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_5.png";
   b5=manage(new Gtk::Image(ifile));
   b_5 = manage(new Gtk::Button()); 
   b_5->add(*b5);
   b_5->set_border_width(0);
   b_5->set_relief(Gtk::RELIEF_NONE);
   b_5->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_6.png";
   b6=manage(new Gtk::Image(ifile));
   b_6 = manage(new Gtk::Button()); 
   b_6->add(*b6);
   b_6->set_border_width(0);
   b_6->set_relief(Gtk::RELIEF_NONE);
   b_6->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_7.png";
   b7=manage(new Gtk::Image(ifile));
   b_7 = manage(new Gtk::Button()); 
   b_7->add(*b7);
   b_7->set_border_width(0);
   b_7->set_relief(Gtk::RELIEF_NONE);
   b_7->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_8.png";
   b8=manage(new Gtk::Image(ifile));
   b_8 = manage(new Gtk::Button()); 
   b_8->add(*b8);
   b_8->set_border_width(0);
   b_8->set_relief(Gtk::RELIEF_NONE);
   b_8->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_9.png";
   b9=manage(new Gtk::Image(ifile));
   b_9 = manage(new Gtk::Button()); 
   b_9->add(*b9);
   b_9->set_border_width(0);
   b_9->set_relief(Gtk::RELIEF_NONE);
   b_9->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_decimal.png";
   bdecimal=manage(new Gtk::Image(ifile));
   b_decimal = manage(new Gtk::Button());
   b_decimal->add(*bdecimal);
   b_decimal->set_border_width(0);
   b_decimal->set_relief(Gtk::RELIEF_NONE);
   b_decimal->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_plus.png";
   bplus=manage(new Gtk::Image(ifile));
   b_plus = manage(new Gtk::Button());
   b_plus->add(*bplus);
   b_plus->set_border_width(0);
   b_plus->set_relief(Gtk::RELIEF_NONE);
   b_plus->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_minus.png";
   bminus=manage(new Gtk::Image(ifile));
   b_minus = manage(new Gtk::Button());
   b_minus->add(*bminus);
   b_minus->set_border_width(0);
   b_minus->set_relief(Gtk::RELIEF_NONE);
   b_minus->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_equal.png";
   bequal=manage(new Gtk::Image(ifile));
   b_equal = manage(new Gtk::Button());
   b_equal->add(*bequal);
   b_equal->set_border_width(0);
   b_equal->set_relief(Gtk::RELIEF_NONE);
   b_equal->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_pgup.png";
   bpgup=manage(new Gtk::Image(ifile));
   b_pgup = manage(new Gtk::Button());
   b_pgup->add(*bpgup);
   b_pgup->set_border_width(0);
   b_pgup->set_relief(Gtk::RELIEF_NONE);
   b_pgup->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_up.png";
   bup=manage(new Gtk::Image(ifile));
   b_up = manage(new Gtk::Button());
   b_up->add(*bup);
   b_up->set_border_width(0);
   b_up->set_relief(Gtk::RELIEF_NONE);
   b_up->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_down.png";
   bdown=manage(new Gtk::Image(ifile));
   b_down = manage(new Gtk::Button());
   b_down->add(*bdown);
   b_down->set_border_width(0);
   b_down->set_relief(Gtk::RELIEF_NONE);
   b_down->set_size_request(40, 41);
   /*
   ifile=basedir + "/keypad_pgdn.png";
   bpgdown=manage(new Gtk::Image(ifile));
   b_pgdown = manage(new Gtk::Button());
   b_pgdown->add(*bpgdown);
   b_pgdown->set_border_width(0);
   b_pgdown->set_relief(Gtk::RELIEF_NONE);
   b_pgdown->set_size_request(40, 41);
   */
   
   ifile=basedir + "/keypad_dhreturn.png";
   breturn=manage(new Gtk::Image(ifile));
   b_return = manage(new Gtk::Button());
   b_return->add(*breturn);
   b_return->set_border_width(0);
   b_return->set_relief(Gtk::RELIEF_NONE);
   b_return->set_size_request(80, 41);
   
   ifile=basedir + "/keypad_bs.png";
   bdelete=manage(new Gtk::Image(ifile));
   b_delete = manage(new Gtk::Button());
   b_delete->add(*bdelete);
   b_delete->set_border_width(0);
   b_delete->set_relief(Gtk::RELIEF_NONE);
   b_delete->set_size_request(40, 41);
   
   attach(*b_plus, 0, 1, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_minus, 1, 2, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_equal, 2, 3, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_delete, 3, 4, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_7, 0, 1, 1, 2, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_8, 1, 2, 1, 2, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_9, 2, 3, 1, 2, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_pgup, 3, 4, 1, 2, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_4, 0, 1, 2, 3, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_5, 1, 2, 2, 3, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_6, 2, 3, 2, 3, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_up, 3, 4, 2, 3, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_1, 0, 1, 3, 4, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_2, 1, 2, 3, 4, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_3, 2, 3, 3, 4, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_0, 0, 1, 4, 5, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_decimal, 1, 2, 4, 5, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_down, 3, 4, 3, 4, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_return, 2, 4, 4, 5, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   //attach(*b_pgdown, 3, 4, 4, 5, GTK_Gtk::SHRINK, 0, 0, 0);
   
   show_all();
   
   b_0->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b0_clicked));
   b_1->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b1_clicked));
   b_2->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b2_clicked));
   b_3->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b3_clicked));
   b_4->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b4_clicked));
   b_5->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b5_clicked));
   b_6->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b6_clicked));
   b_7->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b7_clicked));
   b_8->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b8_clicked));
   b_9->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b9_clicked));
   b_decimal->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bdecimal_clicked));
   b_plus->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bplus_clicked));
   b_minus->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bminus_clicked));
   b_equal->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bequal_clicked));
   b_pgup->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bpgup_clicked));
   b_up->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bup_clicked));
   b_down->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bdn_clicked));
   //b_pgdown->clicked.connect(sigc::mem_fun(this, &BhNumPad::on_bpgdn_clicked));
   b_return->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_breturn_clicked));
   b_delete->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bdelete_clicked));
}

BhNumPad::BhNumPad(Glib::ustring basedir) : Gtk::Table(false, 0)
{
   bCallback=false;
   kf_callback=NULL;
   Glib::ustring ifile;
   
   set_border_width(0);
   set_row_spacings(0);
   set_col_spacings(0);
   this->set_size_request(160, 205);
   
   ifile=basedir + "/keypad_0.png";
   b0=manage(new Gtk::Image(ifile));
   b_0 = manage(new Gtk::Button()); 
   b_0->add(*b0);
   b_0->set_border_width(0);
   b_0->set_relief(Gtk::RELIEF_NONE);
   b_0->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_1.png";
   b1=manage(new Gtk::Image(ifile));
   b_1 = manage(new class Gtk::Button()); 
   b_1->add(*b1);
   b_1->set_border_width(0);
   b_1->set_relief(Gtk::RELIEF_NONE);
   b_1->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_2.png";
   b2=manage(new Gtk::Image(ifile));
   b_2 = manage(new Gtk::Button()); 
   b_2->add(*b2);
   b_2->set_border_width(0);
   b_2->set_relief(Gtk::RELIEF_NONE);
   b_2->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_3.png";
   b3=manage(new Gtk::Image(ifile));
   b_3 = manage(new Gtk::Button()); 
   b_3->add(*b3);
   b_3->set_border_width(0);
   b_3->set_relief(Gtk::RELIEF_NONE);
   b_3->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_4.png";
   b4=manage(new Gtk::Image(ifile));
   b_4 = manage(new Gtk::Button()); 
   b_4->add(*b4);
   b_4->set_border_width(0);
   b_4->set_relief(Gtk::RELIEF_NONE);
   b_4->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_5.png";
   b5=manage(new Gtk::Image(ifile));
   b_5 = manage(new Gtk::Button()); 
   b_5->add(*b5);
   b_5->set_border_width(0);
   b_5->set_relief(Gtk::RELIEF_NONE);
   b_5->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_6.png";
   b6=manage(new Gtk::Image(ifile));
   b_6 = manage(new Gtk::Button()); 
   b_6->add(*b6);
   b_6->set_border_width(0);
   b_6->set_relief(Gtk::RELIEF_NONE);
   b_6->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_7.png";
   b7=manage(new Gtk::Image(ifile));
   b_7 = manage(new Gtk::Button()); 
   b_7->add(*b7);
   b_7->set_border_width(0);
   b_7->set_relief(Gtk::RELIEF_NONE);
   b_7->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_8.png";
   b8=manage(new Gtk::Image(ifile));
   b_8 = manage(new Gtk::Button()); 
   b_8->add(*b8);
   b_8->set_border_width(0);
   b_8->set_relief(Gtk::RELIEF_NONE);
   b_8->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_9.png";
   b9=manage(new Gtk::Image(ifile));
   b_9 = manage(new Gtk::Button()); 
   b_9->add(*b9);
   b_9->set_border_width(0);
   b_9->set_relief(Gtk::RELIEF_NONE);
   b_9->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_decimal.png";
   bdecimal=manage(new Gtk::Image(ifile));
   b_decimal = manage(new Gtk::Button());
   b_decimal->add(*bdecimal);
   b_decimal->set_border_width(0);
   b_decimal->set_relief(Gtk::RELIEF_NONE);
   b_decimal->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_plus.png";
   bplus=manage(new Gtk::Image(ifile));
   b_plus = manage(new Gtk::Button());
   b_plus->add(*bplus);
   b_plus->set_border_width(0);
   b_plus->set_relief(Gtk::RELIEF_NONE);
   b_plus->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_minus.png";
   bminus=manage(new Gtk::Image(ifile));
   b_minus = manage(new Gtk::Button());
   b_minus->add(*bminus);
   b_minus->set_border_width(0);
   b_minus->set_relief(Gtk::RELIEF_NONE);
   b_minus->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_equal.png";
   bequal=manage(new Gtk::Image(ifile));
   b_equal = manage(new Gtk::Button());
   b_equal->add(*bequal);
   b_equal->set_border_width(0);
   b_equal->set_relief(Gtk::RELIEF_NONE);
   b_equal->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_pgup.png";
   bpgup=manage(new Gtk::Image(ifile));
   b_pgup = manage(new Gtk::Button());
   b_pgup->add(*bpgup);
   b_pgup->set_border_width(0);
   b_pgup->set_relief(Gtk::RELIEF_NONE);
   b_pgup->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_up.png";
   bup=manage(new Gtk::Image(ifile));
   b_up = manage(new Gtk::Button());
   b_up->add(*bup);
   b_up->set_border_width(0);
   b_up->set_relief(Gtk::RELIEF_NONE);
   b_up->set_size_request(40, 41);
   
   ifile=basedir + "/keypad_down.png";
   bdown=manage(new Gtk::Image(ifile));
   b_down = manage(new Gtk::Button());
   b_down->add(*bdown);
   b_down->set_border_width(0);
   b_down->set_relief(Gtk::RELIEF_NONE);
   b_down->set_size_request(40, 41);
   /*
   ifile=basedir + "/keypad_pgdn.png";
   bpgdown=manage(new Gtk::Image(ifile));
   b_pgdown = manage(new Gtk::Button());
   b_pgdown->add(*bpgdown);
   b_pgdown->set_border_width(0);
   b_pgdown->set_relief(Gtk::RELIEF_NONE);
   b_pgdown->set_size_request(40, 41);
   */
   
   ifile=basedir + "/keypad_dhreturn.png";
   breturn=manage(new Gtk::Image(ifile));
   b_return = manage(new Gtk::Button());
   b_return->add(*breturn);
   b_return->set_border_width(0);
   b_return->set_relief(Gtk::RELIEF_NONE);
   b_return->set_size_request(80, 41);
   
   ifile=basedir + "/keypad_bs.png";
   bdelete=manage(new Gtk::Image(ifile));
   b_delete = manage(new Gtk::Button());
   b_delete->add(*bdelete);
   b_delete->set_border_width(0);
   b_delete->set_relief(Gtk::RELIEF_NONE);
   b_delete->set_size_request(40, 41);
   
   attach(*b_plus, 0, 1, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_minus, 1, 2, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_equal, 2, 3, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_delete, 3, 4, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_7, 0, 1, 1, 2, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_8, 1, 2, 1, 2, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_9, 2, 3, 1, 2, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_pgup, 3, 4, 1, 2, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_4, 0, 1, 2, 3, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_5, 1, 2, 2, 3, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_6, 2, 3, 2, 3, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_up, 3, 4, 2, 3, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_1, 0, 1, 3, 4, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_2, 1, 2, 3, 4, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_3, 2, 3, 3, 4, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_0, 0, 1, 4, 5, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_decimal, 1, 2, 4, 5, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_down, 3, 4, 3, 4, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   attach(*b_return, 2, 4, 4, 5, Gtk::SHRINK, Gtk::SHRINK, 0, 0);
   //attach(*b_pgdown, 3, 4, 4, 5, GTK_Gtk::SHRINK, 0, 0, 0);
   
   show_all();
   
   b_0->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b0_clicked));
   b_1->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b1_clicked));
   b_2->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b2_clicked));
   b_3->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b3_clicked));
   b_4->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b4_clicked));
   b_5->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b5_clicked));
   b_6->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b6_clicked));
   b_7->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b7_clicked));
   b_8->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b8_clicked));
   b_9->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_b9_clicked));
   b_decimal->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bdecimal_clicked));
   b_plus->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bplus_clicked));
   b_minus->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bminus_clicked));
   b_equal->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bequal_clicked));
   b_pgup->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bpgup_clicked));
   b_up->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bup_clicked));
   b_down->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bdn_clicked));
   //b_pgdown->clicked.connect(sigc::mem_fun(this, &BhNumPad::on_bpgdn_clicked));
   b_return->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_breturn_clicked));
   b_delete->signal_clicked().connect(sigc::mem_fun(*this, &BhNumPad::on_bdelete_clicked));
}

BhNumPad::~BhNumPad()
{  
}

void BhNumPad::on_b0_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_0, 0);
      return;
   }
   
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_0;
   kf_callback(&keyev);
}

void BhNumPad::on_b1_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_1, 0);
      return;
   }
   
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_1;
   kf_callback(&keyev);
}

void BhNumPad::on_b2_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_2, 0);
      return;
   }
   
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_2;
   kf_callback(&keyev);
}

void BhNumPad::on_b3_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_3, 0);
      return;
   }
   
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_3;
   kf_callback(&keyev);
}

void BhNumPad::on_b4_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_4, 0);
      return;
   }
   
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_4;
   kf_callback(&keyev);
}

void BhNumPad::on_b5_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_5, 0);
      return;
   }
   
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_5;
   kf_callback(&keyev);
}

void BhNumPad::on_b6_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_6, 0);
      return;
   }
   
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_6;
   kf_callback(&keyev);
}

void BhNumPad::on_b7_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_7, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_7;
   kf_callback(&keyev);
}

void BhNumPad::on_b8_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_8, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_8;
   kf_callback(&keyev);
}

void BhNumPad::on_b9_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_9, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_9;
   kf_callback(&keyev);
}

void BhNumPad::on_bdecimal_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_DECIMAL, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_period;
   kf_callback(&keyev);
}

void BhNumPad::on_bplus_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_PLUS, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_plus;
   kf_callback(&keyev);
}

void BhNumPad::on_bminus_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_MINUS, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_minus;
   kf_callback(&keyev);
}

void BhNumPad::on_bequal_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_EQUAL, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_equal;
   kf_callback(&keyev);
}

void BhNumPad::on_bpgup_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_PGUP, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_Page_Up;
   kf_callback(&keyev);
}

void BhNumPad::on_bup_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_UP, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_Up;
   kf_callback(&keyev);
}

void BhNumPad::on_bdn_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_DOWN, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_Down;
   kf_callback(&keyev);
}

void BhNumPad::on_bpgdn_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_PGDOWN, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_Page_Down;
   kf_callback(&keyev);
}

void BhNumPad::on_breturn_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_RETURN, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_Return;
   kf_callback(&keyev);
}

void BhNumPad::on_bdelete_clicked()
{
   if(!bCallback){
      keypress_signal.emit(BHNUMPAD_DELETE, 0);
      return;
   }

   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   keyev.keyval=GDK_BackSpace;
   kf_callback(&keyev);
}

}

}
